import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
public class ApfelJuliaApplet extends Applet implements MouseListener, ItemListener{
	JuliaPanel myJulia = new JuliaPanel();
	ApfelPanel myApfel = new ApfelPanel();
	Panel      pCenter = new Panel();
	Panel 	   pNorth  = new Panel();
	CheckboxGroup cg   = new CheckboxGroup();
	Checkbox   c1 = new Checkbox("black & white",false,cg),
			   c2 = new Checkbox("color 1",false,cg),
			   c3 = new Checkbox("color 2",true,cg),
			   c4 = new Checkbox("red (linear)",false,cg),
			   c5 = new Checkbox("red (log)",false,cg),
			   c6 = new Checkbox("red (log 2)",false,cg);
	
	public void init(){
		this.setLayout(new BorderLayout());
		add(BorderLayout.NORTH,pNorth);
		add(BorderLayout.CENTER,pCenter);
		pCenter.setLayout(new GridLayout(1,2));
		pCenter.add(myApfel);
		pCenter.add(myJulia);
		pNorth.add(new Label("Color: "));
		pNorth.setLayout(new FlowLayout(FlowLayout.LEFT));
		add(BorderLayout.SOUTH,new Label("Hanno Rein (http://hanno-rein.de) 2004"));
		pNorth.add(c1);
		pNorth.add(c2);
		pNorth.add(c3);
		pNorth.add(c4);
		pNorth.add(c5);
		pNorth.add(c6);
		myApfel.addMouseListener(this);
		c1.addItemListener(this);
		c2.addItemListener(this);
		c3.addItemListener(this);
		c4.addItemListener(this);
		c5.addItemListener(this);
		c6.addItemListener(this);
	}
	
	
	public void mouseClicked(MouseEvent arg0)  {
		if (arg0.getButton()==2){
			myJulia.x_mid = 0;
			myJulia.y_mid = 0;
			myJulia.pixel = 0.01;
			myJulia.c_re = myApfel.xleft+arg0.getX()*myApfel.pixel;
			myJulia.c_im = myApfel.ytop -arg0.getY()*myApfel.pixel;
			myJulia.repaint();
			Graphics g = myApfel.getGraphics();
			g.setColor(Color.red);
			g.drawRect(arg0.getX()-1,arg0.getY()-1,2,2);
		}
	}	
	
	public void itemStateChanged(ItemEvent e){
		if (e.getItemSelectable()==c1){
			myJulia.colorstyle=0;
			myApfel.colorstyle=0;
			myApfel.repaint();
			myJulia.repaint();
		}
		if (e.getItemSelectable()==c2){
			myJulia.colorstyle=1;
			myApfel.colorstyle=1;
			myApfel.repaint();
			myJulia.repaint();
		}
		if (e.getItemSelectable()==c3){
			myJulia.colorstyle=2;
			myApfel.colorstyle=2;
			myApfel.repaint();
			myJulia.repaint();
		}
		if (e.getItemSelectable()==c4){
			myJulia.colorstyle=3;
			myApfel.colorstyle=3;
			myApfel.repaint();
			myJulia.repaint();
		}
		if (e.getItemSelectable()==c5){
			myJulia.colorstyle=4;
			myApfel.colorstyle=4;
			myApfel.repaint();
			myJulia.repaint();
		}
		if (e.getItemSelectable()==c6){
			myJulia.colorstyle=5;
			myApfel.colorstyle=5;
			myApfel.repaint();
			myJulia.repaint();
		}
	}
	
	public void mouseEntered(MouseEvent arg0)     {}
	public void mouseExited(MouseEvent arg0)      {}
	public void mouseMoved(MouseEvent arg0)       {}
	public void mousePressed(MouseEvent arg0)     {}
	public void mouseReleased(MouseEvent arg0)    {}
}
